# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class Metadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'index': 'str',
        'metadata': 'object',
        'res_id': 'str'
    }

    attribute_map = {
        'links': '_links',
        'index': 'index',
        'metadata': 'metadata',
        'res_id': 'resId'
    }

    def __init__(self, links=None, index=None, metadata=None, res_id=None, local_vars_configuration=None):  # noqa: E501
        """Metadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._index = None
        self._metadata = None
        self._res_id = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if index is not None:
            self.index = index
        if metadata is not None:
            self.metadata = metadata
        if res_id is not None:
            self.res_id = res_id

    @property
    def links(self):
        """Gets the links of this Metadata.  # noqa: E501

        The _links_ list of the _metadata_ resource  # noqa: E501

        :return: The links of this Metadata.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Metadata.

        The _links_ list of the _metadata_ resource  # noqa: E501

        :param links: The links of this Metadata.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def index(self):
        """Gets the index of this Metadata.  # noqa: E501

        The index name of indexed metadata  # noqa: E501

        :return: The index of this Metadata.  # noqa: E501
        :rtype: str
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this Metadata.

        The index name of indexed metadata  # noqa: E501

        :param index: The index of this Metadata.  # noqa: E501
        :type: str
        """

        self._index = index

    @property
    def metadata(self):
        """Gets the metadata of this Metadata.  # noqa: E501

        The object of indexed metadata  # noqa: E501

        :return: The metadata of this Metadata.  # noqa: E501
        :rtype: object
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Metadata.

        The object of indexed metadata  # noqa: E501

        :param metadata: The metadata of this Metadata.  # noqa: E501
        :type: object
        """

        self._metadata = metadata

    @property
    def res_id(self):
        """Gets the res_id of this Metadata.  # noqa: E501

        The _metadata_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this Metadata.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this Metadata.

        The _metadata_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this Metadata.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Metadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Metadata):
            return True

        return self.to_dict() != other.to_dict()
